<template>
  <crud-data-table-delete
    v-model="dialog"
    :item-being-deleted="periodBeingDeleted"
    :loading="isLoading"
    @onAgree="onAgree"
    @onDisagree="onDisagree"
  >
    <template v-slot:itemBeingDelete>
      <span v-html="$t('itemBeingDelete', { title, startDate, endDate })" />
    </template>
    <template v-slot:whatWillHappenWhenDeleted>
      <span v-html="$t('whatWillHappenWhenDeleted')" />
    </template>
  </crud-data-table-delete>
</template>

<script>
  import DatesMixin from '@/mixins/date'

  export default {
    name: 'DeletePeriodDialog',
    mixins: [DatesMixin],
    data () {
      return {
        dialog: false,
        isLoading: false,
        periodBeingDeleted: {},
      }
    },
    computed: {
      title () {
        return this.periodBeingDeleted.title
      },
      startDate () {
        return this.$options.filters.formatDate(this.periodBeingDeleted.startDate)
      },
      endDate () {
        return this.$options.filters.formatDate(this.periodBeingDeleted.endDate)
      },
    },
    created () {
      this.$emit('onDeletePeriod', this.onDeletePeriod)
    },
    methods: {
      onDeletePeriod (period) {
        this.periodBeingDeleted = period
        this.dialog = true
      },
      onAgree () {
        this.isLoading = true
        this.$store.dispatch('periods/deletePeriod', {
          ID: this.periodBeingDeleted.id,
        })
          .then(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'success',
              text: this.$t('deleteSuccess'),
            })
          })
          .catch(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'error',
              text: this.$t('deleteError'),
            })
          })
          .finally(() => {
            this.dialog = false
            this.isLoading = false
          })
      },
      onDisagree () {
        this.dialog = false
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          itemBeingDelete: 'Período: {title} de {startDate} até {endDate}',
          whatWillHappenWhenDeleted: 'Todas as <strong>receitas</strong> e <strong>despesas</strong> associadas a este período também serão excluídas.',
          deleteSuccess: 'Período excluído com sucesso!',
          deleteError: 'Ops... Algo deu errado ao tentar excluir o período. Por favor, tente novamente.',
        },
        'en-US': {
          itemBeingDelete: 'Period: {title} from {startDate} to {endDate}',
          whatWillHappenWhenDeleted: 'All <strong>income</strong> and <strong>expenses</strong> associated with this period will also be excluded.',
          deleteSuccess: 'Period successfully deleted!',
          deleteError: 'Oops... Something went wrong while trying to delete the period. Please try again.',
        },
      },
    },
  }
</script>
